package dev.pfaff.altargui.pathfinder;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;

import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_FKFontClone;
import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_FKFontDestroy;

public record FKFontRef(MemorySegment ptr) {
	public static FKFontRef newAutoDestroy(MemorySegment ptr) {
		return new FKFontRef(ptr.reinterpret(Arena.ofAuto(), ptr_ -> {
			try {
				MH_FKFontDestroy.invokeExact(ptr_);
			} catch (Throwable e) {
				throw new RuntimeException(e);
			}
		}));
	}

	public FKFontRef cloneRef() {
		try {
			return newAutoDestroy((MemorySegment) MH_FKFontClone.invokeExact(this.ptr()));
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
