package dev.pfaff.altargui.pathfinder;

import java.lang.foreign.Arena;
import java.lang.foreign.MemorySegment;

import static dev.pfaff.altargui.pathfinder.Pathfinder.MH_PFCanvasFontContextGetFontByPostScriptName;

public record PFCanvasFontContextRef(MemorySegment ptr) {
	public FKFontRef getFontByPostscriptName(String name) {
		try (var arena = Arena.ofConfined()) {
			var nameBytes = arena.allocateFrom(name);
			var ptr = (MemorySegment) MH_PFCanvasFontContextGetFontByPostScriptName.invokeExact(this.ptr(),
					nameBytes,
					nameBytes.byteSize() - 1);
			if (ptr.equals(MemorySegment.NULL)) throw new RuntimeException(STR."Failed to get font '\{name}'");
			return FKFontRef.newAutoDestroy(ptr);
		} catch (Throwable e) {
			throw new RuntimeException(e);
		}
	}
}
